#### Настройка подынтерфейсов (VLAN) Raspberry Pi

1. Установить необходимый пакет
```bash
sudo apt install vlan
```
2. Создать виртуальный интерфейс
```bash
sudo vi /etc/network/interfaces.d/vlans
```
*пример содержимого файла*
```bash
auto eth0.10
iface eth0.10 inet manual
  vlan-raw-device eth0
```
3. Настройка IP адреса на виртуальном интерфейсе
```bash
sudo vi /etc/dhcpcd.conf
```
*пример настройки*
```bash
# Example static IP configuration:

interface eth0
static ip_address=10.0.20.125/24
static routers=10.0.20.1
static domain_name_servers=1.1.1.1

interface eth0.10
static ip_address=10.0.10.125/24
#static routers=10.0.10.1
#static domain_name_servers=1.1.1.1
```
***static routers (он же шлюз по-умолчанию) может быть только один, поэтому его необходимо использовать где-то в одном месте (или на основном интерфейсе или на интерфейсе VLAN, в зависимости от настроек сети. DNS (static domain_name_servers) также достаточно настроить на одном интерфейсе, на котором этот DNS будет доступен.***

4. Применение изменений
```bash
sudo systemctl restart networking
```

5. Убедиться, что настройки применились можно с помощью `hostname`
```bash
hostname -I
```
или
```bash
ip a
```

***

*По умолчанию в Raspberry для настроек сети используется dhcpcd ~~(не смог разобраться как в нем настраивать подынтерфейсы)~~ **- разобрался, описано выше***  

**Альтернативный вариант настройки с использованием пакета networking.**  
*Необходимо отключить dhcpcd и включить networking*
```bash
sudo systemctl disable dhcpcd
sudo systemctl enable networking
```
редактируем файл настроек сети
```bash
sudo nano /etc/network/interfaces
```
добавим в него строки:
```
# management ip
auto eth0
iface eth0 inet static
        address 192.168.5.1
        netmask 255.255.255.0

# first ntp server
auto eth0.10
iface eth0.10 inet static
        address 192.168.10.1
        netmask 255.255.255.0

# second ntp server
auto eth0.20
iface eth0.20 inet static
        address 192.168.20.1
        netmask 255.255.255.0

# wlan
auto wlan0
iface wlan0 inet dhcp
        wpa-conf /etc/wpa_supplicant/wpa_supplicant.conf
```
сохраняем изменения _ctrl+o_, закрываем редактор _ctrl+x_
для проверки правильности внесенных настроек перезагрузим сеть
```bash
sudo service networking restart
```
если в консоли не появилось сообщений с ошибками, значит всё настроено правильно
увидеть настроенные интерфейсы и ip адреса командой
```bash
ip addr
```

#### Временный подынтерфейс в Linux
```
ip link add link eth0 name eth0.103 type vlan id 103
ip link set up dev eth0.103
ip address add 192.168.130.34/28 dev eth0.103
```